// 002 u_paradox_ado_connection
// 26 jan 2008

// -- (C) John COLIBRI 2008
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_paradox_ado_connection;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl, ExtCtrls, ComCtrls, Grids, DBGrids, DB, ADODB;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    exit_: TButton;
    clear_: TButton;
    PageControl2: TPageControl;
    dir_: TTabSheet;
    DirectoryListBox1: TDirectoryListBox;
    Splitter1: TSplitter;
    Splitter2: TSplitter;
    PageControl1: TPageControl;
    display_: TTabSheet;
    Memo1: TMemo;
    FileListBox1: TFileListBox;
    ADOConnection1: TADOConnection;
    ADODataSet1: TADODataSet;
    DataSource1: TDataSource;
    data_: TTabSheet;
    DBGrid1: TDBGrid;
    procedure FormCreate(Sender: TObject);
    procedure FileListBox1Click(Sender: TObject);
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure DirectoryListBox1Change(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
  public
  end;

var
  Form1: TForm1;

implementation
  uses u_types_constants, u_c_log, u_c_display
      , u_file, u_dir
      , u_c_ini_file
      , u_strings
      ;

    {$R *.DFM}

   

    const k_initial_directory= 'c:\prog\web\utils\downloader\';
            k_extension= '.pas';
            k_file_name= 'pascal.pas';

          k_xxx_path_ini_key=   'ini_xxx_path';
          k_xxx_file_name_ini_key=   'ini_xxx_file_name';

    var g_path: String= k_initial_directory;
        g_file_name: String= k_file_name;

        g_c_ini_file: c_ini_file= Nil;

        g_file_count: Integer= 0;

    procedure display_path_and_file;
      begin
        Form1.Caption:= g_path+ g_file_name;
      end; // display_path_and_file

    procedure my_call_back(p_level: Integer; p_path, p_file_name: String;
        p_pt_data: Pointer);
      begin
        g_path:= p_path; g_file_name:= p_file_name;
        display_path_and_file;

        Inc(g_file_count);

        display('  '+ p_file_name);
      end; // my_call_back

    // -- events

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;

        g_c_ini_file:= c_ini_file.create_ini_file('');
        with g_c_ini_file do
        begin
          // -- whatever is in "fig_ini.txt"
          load_from_default_file;

          // -- initialize the variables with INI or, if none, with constants
          g_path:= f_initialize_parameter(k_xxx_path_ini_key, k_initial_directory);
          g_file_name:= f_initialize_parameter(k_xxx_file_name_ini_key, k_file_name);
        end; // with g_c_ini_file

        set_directory_listbox_directory(DirectoryListBox1, g_path);
        with FileListBox1 do
          ItemIndex:= Items.IndexOf(g_file_name);
      end; // FormCreate

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    procedure TForm1.DirectoryListBox1Change(Sender: TObject);
      begin
        with DirectoryListBox1 do
          g_path:= GetItemPath(ItemIndex)+ '\';
        g_c_ini_file.set_parameter(k_xxx_path_ini_key, g_path);
      end; // DirectoryListBox1Change

    // -- call handler

    procedure TForm1.FileListBox1Click(Sender: TObject);
        // -- the file clicked in the bottom list_box
      begin
        with FileListbox1 do
          g_file_name:= Items[ItemIndex];

        g_c_ini_file.set_parameter(k_xxx_file_name_ini_key, g_file_name);

        g_file_count:= 0;
        my_call_back(0, g_path, g_file_name, Nil);
      end; // FileListBox1Click

    procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
      begin
        g_c_ini_file.save_to_default_file;
      end; // FormClose


end.


